config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  resources :cases

  # resources :registrations
  resources :committees do
    resources :registrations, only: :index
    resources :meetings do
      match :edit_agenda, via: :get
      match :generate_agenda, via: :get

      resources :registrations
      match :increment_max_candidates_number, via: :get
      match :decrement_max_candidates_number, via: :get
      match :approve, via: :get
    end
  end

  root 'home#index'
  match 'home/private_index' => 'home#private_index', via: :get

  match 'get_permitted_keywords' => 'home#permitted_keywords_get', via: :get
  match 'set_permitted_keywords' => 'home#permitted_keywords_set', via: :get

  # omniauth
  get '/auth/:provider/callback' => 'user_sessions#create'
  get '/auth/failure' => 'user_sessions#failure'
  get 'auth/autologin' => 'user_sessions#autologin'

  # Custom logout
  match '/logout', to: 'user_sessions#destroy', via: :all
end

app/models/committee.rb
# frozen_string_literal: true
class Committee < ApplicationRecord
  # t.string   "name",                                   null: false
  # t.datetime "created_at",                             null: false
  # t.datetime "updated_at",                             null: false
  # t.string   "zaki_committee_id"
  # t.integer  "minutes_per_candidate",     default: 30
  # t.integer  "default_candidates_number", default: 2
  # t.index ["name"], name: "index_committees_on_name", unique: true, using: :btree

  # validations
  validates :name, presence: true, uniqueness: true
  validates :zaki_committee_id, presence: true
  validates :minutes_per_candidate, :default_candidates_number, presence: true,
                                                                numericality: { only_integer: true }

  # relations
  has_many :meetings, dependent: :restrict_with_exception
  has_many :registrations, through: :meetings, dependent: :restrict_with_exception

  # rest instance methods
  def default_meeting_time
    minutes_per_candidate * default_candidates_number
  end
end

app/controllers/committees_controller.rb
# frozen_string_literal: true
class CommitteesController < ApplicationController
  before_action :set_committee, only: [:show, :edit, :update, :destroy]
  skip_before_action :login_required, only: :show

  # GET /committees
  # GET /committees.json
  def index
    @committees = Committee.all
  end

  # GET /committees/1
  # GET /committees/1.json
  def show
    return if json_request? || current_user.present?
    permitted_keywords_get(params[:force_permitted_keyword_get])
  end

  # GET /committees/new
  def new
    @committee = Committee.new
  end

  # GET /committees/1/edit
  def edit; end

  # POST /committees
  # POST /committees.json
  def create
    @committee = Committee.new(committee_params)

    respond_to do |format|
      if @committee.save
        format.html { redirect_to @committee, notice: t(:committee_successfully_created) }
        format.json { render :show, status: :created, location: @committee }
      else
        format.html { render :new }
        format.json { render json: @committee.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /committees/1
  # PATCH/PUT /committees/1.json
  def update
    respond_to do |format|
      if @committee.update(committee_params)
        format.html { redirect_to @committee, notice: t(:committee_successfully_updated) }
        format.json { render :show, status: :ok, location: @committee }
      else
        format.html { render :edit }
        format.json { render json: @committee.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /committees/1
  # DELETE /committees/1.json
  # TODO: what about destroy? delete all related meetings or just hide it
  def destroy
    @committee.destroy
    respond_to do |format|
      format.html { redirect_to committees_url, notice: t(:committee_successfully_destroyed) }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_committee
    @committee = Committee.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def committee_params
    params.require(:committee).permit(:name, :zaki_committee_id, :minutes_per_candidate,
                                      :default_candidates_number)
  end
end

app/helpers/committees_helper.rb
# frozen_string_literal: true
module CommitteesHelper
end

app/views/committees/_form.html.haml
= form_for committee do |f|
  - if committee.errors.any?
    .container-fluid
      .card.card-outline-danger#error-explanation
        .card-block
          %h4
            = t('errors', count: committee.errors.count)
            = t('error_message', count: committee.errors.count)
          %ul.list-group
            - committee.errors.full_messages.each do |msg|
              %li.list-group-item= msg
    .ls40

  .field.form-group
    = f.label :name
    = f.text_field :name, class: 'form-control'
  .field.form-group
    = f.label :minutes_per_candidate
    = f.text_field :minutes_per_candidate
  .field.form-group
    = f.label :default_candidates_number
    = f.text_field :default_candidates_number
  .actions.d-inline-block.float-right
    = f.submit t(:save), class: 'btn btn-success'

:javascript
  $('#committee_minutes_per_candidate').spinner()
  $('#committee_default_candidates_number').spinner()

app/views/committees/edit.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs',
  locals: { final_title: t(:edit_committee) }

.col-md-4.offset-md-4
  = render 'form', committee: @committee

  = link_to t(:back), :back, class: 'btn btn-secondary'

app/views/committees/index.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs',
  locals: { final_title: t(:listing_committees) }

  / enable when formsub will be available without ZakiApp
  / = render 'shared/additional_menu' do
  /   = link_to new_committee_path,
  /   class: 'nav-link btn btn-success' do
  /     %i.fa.fa-plus-square-o
  /     %span New Committee

= render 'shared/alerts'

.col-md-6.offset-md-3
  %table.table
    %thead
      %tr
        %th= t(:name)
        %th

    %tbody
      - @committees.each do |committee|
        %tr
          %td= link_to committee.name, committee
          - if current_user.present?
            %td
              .btn-group
                = link_to t(:edit), edit_committee_path(committee),
                class: 'btn btn-secondary'
                = link_to t(:destroy), committee,
                method: :delete, data: { confirm: t(:confirm_delete) },
                class: 'btn btn-warning'

app/views/committees/new.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs',
  locals: { final_title: t(:new_committee) }

.col-md-4.offset-md-4
  = render 'form', committee: @committee

  = link_to t(:back), committees_path, class: 'btn btn-secondary'

app/views/committees/show.html.haml
.row.second-bar
  = render template: 'shared/breadcrumbs',
  locals: { final_title: t(:meetings) }

  - if current_user.present?
    = render 'shared/additional_menu' do
      = link_to new_committee_meeting_path(@committee),
      class: 'nav-link btn btn-success' do
        %i.fa.fa-plus-square-o
        %span= t(:new_meeting)
      = link_to edit_committee_path(@committee), class: 'btn btn-secondary',
      title: t(:edit_committee), 'data-toggle': 'tooltip',
      'data-placement': 'bottom' do
        %i.fa.fa-edit
        %span.hidden-sm-up= t(:edit)
      = link_to @committee,
      method: :delete, data: { confirm: t(:confirm_delete) },
      class: 'btn btn-danger', title: t(:delete_committee),
      'data-toggle': 'tooltip', 'data-placement': 'bottom',
      'data-offset': '0 15' do
        %i.fa.fa-trash-o
        %span.hidden-sm-up= t(:delete)

= render 'shared/alerts'

.col-md-4.offset-md-4
  .ls60.hidden-sm-down
  .ls20.hidden-md-up
  - if current_user.present?
    = link_to meetus_new_meeting_url, target: '_blank',
    class: 'btn btn-primary btn-block' do
      %i.fa.fa-calendar
      = t(:plan_meeting)
    .ls20
  %ul.list-group
    %li.list-group-item.list-group-item-info
      %h5= t(:approved_meetings)
    - @committee.meetings.approved.future.each do |meeting|
      %li.list-group-item= link_to meeting.name, [@committee, meeting]
    - if @committee.meetings.approved.future.empty?
      %li.list-group-item
        = t(:no_meetings)
        &nbsp;
        = link_to new_committee_meeting_path(@committee) do
          = t(:add) + ' ' + t(:new_meeting).downcase